Guerilla UX testing: a GNOME switcher
Open, Needs TriagePublic

Description

A fellow who rides the bus with me has decided to switch from GNOME to Plasma. I have approximately 11 minutes every day in which I can help him and observe his use of our software.

User profile:

  • Public high school chemistry teacher, approximately 45 years of age.
  • Fairly technically proficient. Uses Fedora on his laptop (installed it himself). Talks to me about GTK. Expresses curiosity about architectural details of GNOME vs Plasma. Has recently installed Plasma alongside GNOME on Fedora 27 and can switch between them in the GDM login screen.
  • Let's call him Bob.

Task #1: get a macOS/Unity/GNOME-on-Ubuntu style vertical Dock on the left hand side of the screen

Subtask: move the panel to the left side of the screen

  • Bob right-clicks on empty area of the panel and looks for a menu item to change the position. Does not find one. Does not click on Context menuConfigure Task Manager... (though this would not have helped). Does not go to Context menuPanel OptionsConfigure Panel... (which would have helped). Bob gets stuck and asks for help.
  • I teach Bob about Panel Edit Mode by showing him the hamburger button at the end of the panel, which he had ignored.
  • Bob enters Panel Edit Mode and finds the Screen Edge button quickly. He clicks on the button and nothing happens. Clicks on it again a few times. Eventually notices that seems to drag the panel when he clicks sloppily (the grabbing hand cursor did not seem to help). Eventually figures out how to drag the panel to the left side of the screen.
  • Bob clicks the hamburger button to leave Panel Edit Mode.
  • Bob clicks on the Kickoff button and immediately hits a really bad bug: https://bugs.kde.org/show_bug.cgi?id=395390. Bob gets completely stuck and rather frustrated and asks for help. I show him how to kill and restart plasmashell from KRunner and he moves on.

Subtask: switch from Task Manager to Icons-Only Task Manager

  • Bob right-clicks on empty area of panel and sees Alternatives... It does not occur to him to click on it. Bob enters Panel Edit Mode once more and right-clicks on various things and clicks on More Settings... Nothing helps. Bob asks for help.
  • I tell Bob to click on Alternatives.... Bob hovers over items while in Panel Edit Mode and does not see Alternatives.... Bob eventually finds it while right-clicking on an empty area of the panel and opens it.
  • Bob realizes immediately that he needs an Icons-Only Task Manager and selects it.

Subtask: add apps to Icons-Only Task Manager

  • Bob expresses the desire to add apps to his new IOTM. Bob opens Kickoff, right-clicks on Firefox, and chooses Add to Panel, creating a standalone launcher.
  • Bob clicks on the Firefox icon and a new IOTM entry is created, which confuses Bob, because now there seem to be two Firefoxes (this is https://bugs.kde.org/show_bug.cgi?id=390817). Bob is utterly baffled by this and asks for help.
  • I explain the difference between launcher widgets and pinned apps. Bob immediately grasps the concept, but expresses mild frustration that the distinction exists.
  • Both then successfully adds more apps to his IOTM by opening them and then pinning them.

Overall it was a fairly rocky first-run session. :/

Macro recommendations:

  • Radically improve the UX for switching between common panel UIs (e.g. Windows XP style task var vs Dock): D24223, T11746
  • Alternatively, switch to using a vertical IOTM by default: T12441
  • Resolve the problem of panel launchers being confusing when pinned apps exist (https://bugs.kde.org/show_bug.cgi?id=390817). In particular, launcher widgets seem pointless when using an IOTM, since the whole point of an IOTM is that it's full of always-visible app icons. Pinned apps are never useful here.
  • Improve the UX vis-a-vis panel editability and modes T10190, D23951

Micro recommendations:

  • Fix https://bugs.kde.org/show_bug.cgi?id=395390 ASAP
  • Change the hamburger menu icon on the panel to something familiar and distinctive, like maybe the common settings-configure icon we use everywhere else
  • Show Alternatives... in the hover pop-up while in Panel edit mode: https://bugs.kde.org/show_bug.cgi?id=401089
  • Move all items in the Panel Options submenu into its parent D23951
  • While in Panel Edit Mode, make it easier to figure out that you need to drag the button to reposition the panel to a different screen edge

Related Objects

Mentioned In
T12441: Consider using a vertical Icons-Only Task Manager populated with apps, and a thickened panel
R242:bbe0148db5d1: Improve panel options menu entries
D24223: [RFC] Add global themes that mimic other platforms' workflows
D23951: Improve panel options menu entries
D23950: Only show "Add Widgets..." panel context menu option in panel edit mode
R242:144bb9071541: Fix incorrect initial tabs position for vertical tab bars
R242:e2cd97d822d3: Fix incorrect initial tabs position for vertical tab bars
R119:2054d9be40bc: Fix incorrect Kickoff tab bar layout for vertical panels
T11094: Improve discoverability of widget configuration
R119:c308122688ee: Add alternatives button to applet configuration in panel edit mode
R119:1ae7f9fece38: Change panel edit mode icon from from a hamburger icon to a configure icon
R119:185c0d38381c: [Panel Edit Mode] Change screen edge button hover cursor, add icons to screen…
Mentioned Here
T12441: Consider using a vertical Icons-Only Task Manager populated with apps, and a thickened panel
D24223: [RFC] Add global themes that mimic other platforms' workflows
T11746: Make it possible to only apply certain parts of a Global Theme
D23951: Improve panel options menu entries
T11052: Accent Colors, Color Ramps and other improvements to theming.
T10190: (Re)define modes when editing panels and widgets
D17323: [Panel Edit Mode] Change screen edge button hover cursor, add icons to screen edge button and panel size button, add tooltips
D17321: Change panel edit mode icon from from a hamburger icon to a configure icon
ngraham created this task.Nov 16 2018, 3:38 AM
abetts added a subscriber: abetts.Nov 16 2018, 4:54 AM

Overall, these changes are sensitive and go with the times. I don't particularly like a dock on the left, but allowing this feature is good IMHO. Others like icons-only, I am all for.

ndavis added a subscriber: ndavis.Nov 16 2018, 8:06 AM

While in Panel Edit Mode, use buttons to determine screen edge rather than making the user manually drag the panel

Please do not forget, that we can drag the panels also to other monitors, so this should be possible with buttons too.

ngraham updated the task description. (Show Details)Nov 16 2018, 2:58 PM
trickyricky26 added a subscriber: trickyricky26.EditedNov 16 2018, 4:11 PM

While in Panel Edit Mode, use buttons to determine screen edge rather than making the user manually drag the panel

I think this should not be changed as I think the existing drag action is an intuitive and elegant solution as opposed to a bunch of buttons or a submenu.
However, there should be a clear indicator you have to drag with the button, like a hover text (maybe that could also appear when you click the surface without dragging it) and an icon like transform-move displayed alongside the drag surface.

I think the other changes are quite sensible.

The transform-move icon:

While in Panel Edit Mode, use buttons to determine screen edge rather than making the user manually drag the panel

I think this should not be changed as I think the existing drag action is an intuitive and elegant solution as opposed to a bunch of buttons or a submenu.
However, there should be a clear indicator you have to drag with the button, like a hover text (maybe that could also appear when you click the surface without dragging it) and an icon like transform-move displayed alongside the drag surface.

I think the other changes are quite sensible.

The transform-move icon:

I agree, an icon is sorely needed. When I tried to move the panel for the first time 2 years ago, I couldn't figure out how to do it because the "Screen Edge" button didn't seem to do anything. As a method for moving panels around, it works, but there's nothing about the button that says "Drag me!". The Width button could use an icon as well.

GB_2 added a comment.Dec 8 2018, 10:11 PM

Would it help if "Alternatives" got renamed to "Alternative Widgets"?
It already says that in the title of the alternatives popup.

GB_2 added a comment.Dec 12 2018, 6:23 PM

Can D17323 and D17321 be landed?

In T10047#170029, @GB_2 wrote:

Can D17323 and D17321 be landed?

I'd really like some Plasma people to approve first.

ngraham updated the task description. (Show Details)Dec 15 2018, 8:55 PM
ngraham updated the task description. (Show Details)
alex-l added a subscriber: alex-l.Jan 21 2019, 2:16 PM

Just a thought: since "alternatives" pattern seems to work, what if Bob find as alternative to application launcher (Kick off) a full screen launcher like the GNOME one, that:

  • list favorited apps on the left, with a button to show all apps in categories in the middle of the screen
  • show current windows in the middle of the screen (like Present Window) by default
  • list virtual desktop on the right like GNOME with the capability to move windows there
  • show a focused search box at the top so if the user start to type windows are filtered (like in Present Window) and KRunner results are shown too

This is the UX more similar to the GNOME one (starting this menu with meta/windows button should work too, like in GNOME) that I can think using Plasma concepts.

rooty added a subscriber: rooty.Jan 21 2019, 2:46 PM

what about latte dock? it's amazing for mac converts (myself included) - is there any way to include it in/with plasma? it provides a true mac-like dock experience

Just a thought: since "alternatives" pattern seems to work, what if Bob find as alternative to application launcher (Kick off) a full screen launcher like the GNOME one, that:

  • list favorited apps on the left, with a button to show all apps in categories in the middle of the screen
  • show current windows in the middle of the screen (like Present Window) by default
  • list virtual desktop on the right like GNOME with the capability to move windows there
  • show a focused search box at the top so if the user start to type windows are filtered (like in Present Window) and KRunner results are shown too

    This is the UX more similar to the GNOME one (starting this menu with meta/windows button should work too, like in GNOME) that I can think using Plasma concepts.

Yep, agreed. However Bob wasn't looking for a dashboard UI; he very explicitly wanted a "Dock" on the left.

davidhurka added a subscriber: davidhurka.EditedFeb 2 2019, 7:47 PM
@ngraham wrote:
  • Bob right-clicks on empty area of panel and sees "Alternatives..." It does not occur to him to click on it.

When moving to another OS, I would avoid to click on buttons with "...", until I know what will happen. I would fear something like Internet Explorer popping up and loading a Bing search for "Alternatives".

Additionally, "..." indicates to close all menus, so these items are always my last I try.

I suggest to name it Alternatives to “Task Manager”, and to make it a submenu which holds all the alternatives as radio button list, instead of opening a new widget. (There could be an item "Show all...", which opens this widget.)

There could be a menu item “Help...”, which explains all the terms like Panel, Widget, Launcher, Task Manager, System Tray,... It could just open Help Center -> Plasma Manual -> Using Plasma (-> The Panel). There would be a screenshot like this:


Even in my mother tongue I didn’t know what exactly the “Systemabschnitt der Kontrollleiste” (System Tray) is. Everything could be related to the system...

rooty added a comment.Feb 4 2019, 8:33 PM

Yep, agreed. However Bob wasn't looking for a dashboard UI; he very explicitly wanted a "Dock" on the left.

with or without a top/finder bar?

Yep, agreed. However Bob wasn't looking for a dashboard UI; he very explicitly wanted a "Dock" on the left.

with or without a top/finder bar?

Didn't seem to be a high priority. The first thing he wanted was a left Dock/IOTM. It's possible he would have wanted a top bar too, since that's that GNOME has and he was fairly well accustomed to GNOME's UI.

Yep, agreed. However Bob wasn't looking for a dashboard UI; he very explicitly wanted a "Dock" on the left.

with or without a top/finder bar?

That would be Add Panel -> Application Menu Bar, right?

GB_2 updated the task description. (Show Details)Apr 17 2019, 7:30 PM
GB_2 updated the task description. (Show Details)Apr 21 2019, 2:41 PM

Radically improve the UX for switching between common panel UIs (e.g. Windows XP style task var vs Dock). This probably needs its own Phab task.

There's now a plasma widget that does just this (video).

Zorin OS (a GNOME Shell based distro) also has something similar we could draw inspiration from:

I think the task should be expanded to include their accent picker, and auto-theme features as well:

Thankfully we have Look-And-Feel packages that can do this. What's needed is for someone (maybe a new "KDE VDG" account?) to publish some minimal LNF packages for Windows, Mac, and Unity style layouts. There are already a few that do this on store.kde.org, but they change everything else too, not just the panel layout and task manager. Maybe we could even put them in a new repo (plasma-workspace-look-and-feel-extras)? So that distros could easily ship with them? Or we could put them in the existing kdeplasma-extras repo.

I wasn't aware of the widget which is very interesting. I came to add that Feren OS Next is using Plasma and includes a theme tool that might also be worth taking a look at. It includes the ability to apply layouts as part of switching a theme. Also, MATE Tweak has a layout feature that provides packaged layouts that make changing them quite simple.

I'd like to step in here if it's fine. I've been working on Feren OS Next, a Plasma-using Ubuntu Distribution that aims to do multiple things. One of those things happens to be providing a more-complete Look & Feel layout application process which affects more than what it currently does.
Examples of things it also affects includes:

  • The current Latte Dock layout being used
  • The titlebar buttons layout in both KWin and GTK Headerbars (when used in conjunction with an XSettings Daemon like the one Feren OS Next uses, otherwise only KWin is affected)
  • The applied GTK 2 and 3 theme
  • The icon set applied to GTK 2 and 3 Applications to add consistency
  • The cursor theme applied to GTK 2 and 3 Applications for the same reason
  • Whether titlebars are hidden on maximise
  • Whether to assign Meta input to Latte Dock or Plasmashell (this was before I found out that Latte Dock made that an option in their Settings window)
  • More

I've put a GitHub up for the source code if anyone's interested, outside of the XSettings Daemon as that's not something you people will probably be interested in given Plasma Wayland seems to apply GTK Themes on-the-fly now, at least for me anyway...
https://github.com/feren-OS/Themer-Plasma

If this can be of any help for you on your quest to make this a thing, I'd be more than happy to see some of the concepts used here be used upstream in KDE Plasma.

Thanks for the explanation @The-Feren-OS-Dev, this is tangentially related you might be interested in T11052 as well

ngraham updated the task description. (Show Details)Aug 9 2019, 1:24 PM
GB_2 updated the task description. (Show Details)Sep 23 2019, 4:49 PM
GB_2 updated the task description. (Show Details)
GB_2 updated the task description. (Show Details)Oct 21 2019, 5:54 PM
GB_2 updated the task description. (Show Details)
ngraham updated the task description. (Show Details)Dec 28 2019, 4:43 PM
ngraham moved this task from Backlog/Planned to Sent to dev on the VDG board.Dec 28 2019, 8:50 PM

Has anyone ever suggested hiding windows when editing the panel?
When moving plasmoids can happen that you move them outside the panel putting them on the desktop and you don't even notice it.

There could be a menu item “Help...”, which explains all the terms like Panel, Widget, Launcher, Task Manager, System Tray,... It could just open Help Center -> Plasma Manual -> Using Plasma (-> The Panel). There would be a screenshot like this:


Even in my mother tongue I didn’t know what exactly the “Systemabschnitt der Kontrollleiste” (System Tray) is. Everything could be related to the system...

I think that if you have to explain it, it's not clear enough.
The Feren OS approach is the right direction to take.
Hide all the 'advanced' settings and let the user choose from a layout when logging in for the first time.
I'm trying to convince friend and colleagues (that already use linux) to switch to KDE Plasma but everytime I get stucked in explaining "how to add an app to the panel".
Actually you have to choose from:

  • Add to desktop
  • Add to panel (object)
  • Pin to app bar (icon only process manager)
  • Add to favorites
  • Try to drag the icon from Application launcher to the panel
  • ....